/*
 *  Ipd version 1.0, Copyright (C) 1995 G. Hutchings
 *  Ipd comes with ABSOLUTELY NO WARRANTY.
 *  This is free software, and you are welcome to redistribute it
 *  under certain conditions; see the file COPYING for details.
 */

/* Rule function header */

#ifndef RULE_H
#define RULE_H

#define MIN(a, b)	((a) < (b) ? (a) : (b))
#define MAX(a, b)	((a) > (b) ? (a) : (b))
#define ABS(a)		((a) > 0 ? (a) : -(a))
#define DIFF(a, b)	ABS((a)-(b))

#define COOPERATE	1
#define DEFECT		2

#define TEMPTATION	5
#define REWARD		3
#define PUNISHMENT	1
#define SUCKER		0

#define NAME(n)		Rules[n].name
#define SYM(n)		Rules[n].sym

struct rule {
    char *name;			/* Rule name */
    int (*func)(int turn, int *me, int *you); /* Its function */
    char sym;			/* Its symbol */
};

struct entry {
    int rule;			/* Rule no. */
    int num;			/* No. of instances (weighting) */
    int games;			/* No. of games played */
    double score;		/* Current score */
};

struct loc {
    int rule[2];		/* Current/next rules */
    int score;			/* Current score */
    int played;			/* Whether played this generation */
};

extern struct rule Rules[];

#endif
