/*
 *  Ipd version 1.0, Copyright (C) 1995 G. Hutchings
 *  Ipd comes with ABSOLUTELY NO WARRANTY.
 *  This is free software, and you are welcome to redistribute it
 *  under certain conditions; see the file COPYING for details.
 */

#ifndef lint
static char rcsid[] = "$Id: urand.c,v 1.1 1995/06/07 13:41:44 glen Exp $";
#endif

/* Ultimate random number generator */
/* Marsaglia & Zaman (.EXE magazine, Nov '92) */

#include "config.h"

/* Constants & alternatives */
#define NK	37		/* 21 */
#define NJ	24		/*  6 */
#define NV	14		/*  8 */

/* Random number array & pointer */
static unsigned long rnb[NK];
static int ptr = 0;

static unsigned long borrow = 0L;

/* Return a random number */
unsigned long
urand()
{
    unsigned long pdiff, t;
    int i, k;

    ptr++;
    if (ptr < NK)
	return rnb[ptr];
    ptr = 0;

    for (i = 0, k = NK - NJ; i < NK; i++, k++) {
	/* Calculate next NK values */
	if (k == NK)
	    k = 0;
	t = rnb[k];

	/* Clever bit */
	pdiff = t - rnb[i] - borrow;
	if (pdiff < t)
	    borrow = 0;
	if (pdiff > t)
	    borrow = 1;
	rnb[i] = pdiff;
    }

    return rnb[0];
}

/* Initialise random numbers */
void
irand(unsigned long seed)
{
    unsigned long m = 1L;
    int i, in;

    borrow = 0L;
    ptr = 0;
    rnb[0] = seed;

    /* Fill initialisation vector */
    for (i = 1; i < NK; i++) {
	in = (NV * i) % NK;
	rnb[in] = m;
	m = seed - m;
	seed = rnb[in];
    }

    /* "Warm-up" the generator */
    for (i = 0; i < 1000; i++)
	urand();
}
